
package com.javacodegeeks.examples.logbackencoderexample;

import org.slf4j.LoggerFactory;

import ch.qos.logback.classic.Logger;
import ch.qos.logback.classic.LoggerContext;
import ch.qos.logback.classic.encoder.PatternLayoutEncoder;
import ch.qos.logback.classic.spi.ILoggingEvent;
import ch.qos.logback.core.FileAppender;

public class ApplicationStarter {

	public static void main( final String[] args ) {

		// Create the root logger.
		final Logger rootLogger = ( Logger ) LoggerFactory.getLogger( Logger.ROOT_LOGGER_NAME );
		final LoggerContext loggerContext = rootLogger.getLoggerContext();
		loggerContext.reset();

		// Create the PatternLayoutEncoder
		final PatternLayoutEncoder encoder = new PatternLayoutEncoder();
		encoder.setContext( loggerContext );
		encoder.setPattern( "[%thread] %-5level %logger{35} - %msg%n" );
		encoder.setOutputPatternAsHeader( true );
		encoder.start();

		// Create the FileAppender
		final FileAppender< ILoggingEvent > fileAppender = new FileAppender< ILoggingEvent >();
		fileAppender.setContext( loggerContext );
		fileAppender.setFile( "c:/logs/geldis.log" );
		fileAppender.setEncoder( encoder );
		fileAppender.start();

		// Add the file appender to the root logger.
		rootLogger.addAppender( fileAppender );

		// write info log.
		rootLogger.info( "pattern layout encoder info" );
	}
}
